---
title: RTCPeerConnection.onnegotiationneeded
slug: Web/API/RTCPeerConnection/onnegotiationneeded
tags:
  - Event Handler
  - Experimental
  - Property
  - RTCPeerConnection
  - Reference
  - WebRTC
  - onnegotiationneeded
---
<p>{{APIRef("WebRTC")}}</p>

<p>The {{domxref("RTCPeerConnection")}} interface's <strong><code>onnegotiationneeded</code></strong> property is an {{domxref("EventListener")}} which specifies a function which is called to handle the {{event("negotiationneeded")}} event when it occurs on an {{domxref("RTCPeerConnection")}} instance. This event is fired when a change has occurred which requires session negotiation. This negotiation should be carried out as the offerer, because some session changes cannot be negotiated as the answerer.</p>

<p>Most commonly, the {{event("negotiationneeded")}} event is fired after a send track is added to the {{domxref("RTCPeerConnection")}}. If the session is modified in a manner that requires negotiation while a negotiation is already in progress, no {{event("negotiationneeded")}} event will fire until negotiation completes, and only then if negotiation is still needed.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCPeerConnection</em>.onnegotiationneeded = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>This should be set to a function you provide which is passed a single parameter: an {{domxref("Event")}} object containing the {{event("negotiationneeded")}} event. There's no additional information provided in the event; anything you need, you can get by examining the <a href="/en-US/docs/Web/API/RTCPeerConnection#Properties">properties of the <code>RTCPeerConnection</code></a>.</p>

<h2 id="Example">Example</h2>

<p>This example, derived from the example in <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>, establishes a handler for {{event("negotiationneeded")}} events to handle creating an offer, configuring the local end of the connection, and sending the offer to the remote peer.</p>

<pre class="brush: js">pc.onnegotiationneeded = function() {
  pc.createOffer().then(function(offer) {
    return pc.setLocalDescription(offer);
  })
  .then(function() {
      // Send the offer to the remote peer through the signaling server
    });
  })
  .catch(reportError);
}</pre>

<p>First, it creates the offer by calling {{domxref("RTCPeerConnection.createOffer", "createOffer()")}}. When that succeeds, the offer is passed into {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} to set the local description for the connection. Once that's succeeded in turn, the offer can be sent to the signaling server for delivery to the remote peer.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-onnegotiationneeded', 'RTCPeerConnection.onnegotiationneeded') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.onnegotiationneeded")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("negotiationneeded")}} event and its type, {{domxref("Event")}}.</li>
</ul>
